class PfeedCustomizationGenerator < Rails::Generators::Base
  attr_reader :past_classname
  attr_reader :past_varname

  source_root File.expand_path('../templates', __FILE__)
  argument :model, :type => :string, :required => true 
  argument :action_name, :type => :string,:required => true

  def initialize_pfeed_customization
    raise "#{model.to_s.classify} must define '#{action_name.underscore}' method" unless model.to_s.classify.constantize.methods.include? action_name.underscore
    
    @model = model
    @current_action = action_name.to_s.underscore
    @past_action = ParolkarInnovationLab::SocialNet::PfeedUtils.attempt_pass_tense(@current_action)
    @past = @model.downcase + '_' + @past_action
    @past_classname = @model.capitalize + @past_action.capitalize
    @past_varname = @model.downcase + '_' + @past_action.downcase
    @model_filename =  @past + '.rb'
    @view_filename = '_' + @past + '.html.erb'
  end

  def manifest
    template('pfeed_model.rb', "app/models/pfeeds/#{@model_filename}")
    template('pfeed_view.html.erb', "app/views/pfeeds/#{@view_filename}")
   
  end


end
